/* single linked list */

#include<iostream.h>
#include<conio.h>
#include<process.h>
#include<alloc.h>

struct node
{
int val;
struct node *next;
};

void insertbeg(struct node **list,int value);
void insertend(struct node **list,int value);
void addaf(struct node *list,int y,int after);
void addbf(struct node **list,int y,int before);
struct node *search(struct node *ptr,int item);
int delbeg(struct node **list);
int delend(struct node **list);
int delaf(struct node *list,int after);
int deln(struct node **list,int s);
int delbf(struct node **list,int before);
void show(struct node *list);
void travrev(struct node *list);
void deletelist(struct node **list);

void insertbeg(struct node **list,int value)
{
struct node *q;
q=(struct node *)malloc(sizeof(struct node));
q->val=value;

if(*list==NULL)
{
q->next=NULL;
*list=q;
}
else
{
q->next=*list;
*list=q;
}
}

void insertend(struct node **list,int value)
{
struct node *p,*q;
q=(struct node *)malloc(sizeof(struct node));
q->val=value;
q->next=NULL;

if(*list==NULL)
{
*list=q;
}

else
{
p=*list;
while(p->next!=NULL)
{
p=p->next;
}
p->next=q;
}
}

struct node *search(struct node *ptr,int item)
  {
   while((ptr!=NULL)&&(ptr->val!=item))
   {
     ptr=ptr->next;
    }
  if(ptr->val==item)
  return ptr;
  else
  return NULL;
    }

void addaf(struct node *list,int y,int after)
  {
   struct node *loc,*temp,*ptr;
    ptr=list;
   loc=search(ptr,after);
   if(loc==NULL)
    {
     cout<<"\n element not found";
     return;
     }
   temp=(struct node *)malloc(sizeof(struct node));
   temp->val=y;
   temp->next=loc->next;
   loc->next=temp;
    }


void addbf(struct node **list,int y,int before)
  {
    struct node *temp,*ptr,*q;
    ptr=*list;
    q=NULL;
    while((ptr!=NULL)&&(ptr->val!=before))
    {
    q=ptr;
    ptr=ptr->next;
    }

    if(ptr==NULL)
    {
    cout<<"\n element not found";
    return;
    }

    temp= (struct node *)malloc(sizeof(struct node));
    temp->val=y;

    if(q==NULL)
    {
    temp->next=*list;
    *list=temp;
     }
    else
    {
    temp->next=q->next;
    q->next=temp;
    }
    }



int delbeg(struct node **list)
{
int t=-1;
struct node *ptr;
if(*list==NULL)
return t;

ptr=*list;
t=(*list)->val;
*list=(*list)->next;
free(ptr);
return t;
}

int delend(struct node **list)
{
int l=-1;
struct node *ptr,*temp;

if(*list==NULL)
return l;

else
{
if((*list)->next==NULL)
{
ptr=*list;
l=(*list)->val;
*list=NULL;
free(ptr);
}
else
{
temp=NULL;
ptr=*list;

while(ptr->next!=NULL)
{
temp=ptr;
ptr=ptr->next;
}
l=ptr->val;
temp->next=NULL;
free(ptr);
}
return l;
}
}

int delaf(struct node *list,int after)
  {
  int x=-1;
    struct node *loc,*temp,*ptr;
    ptr=list;
    loc=search(ptr,after);
    if(loc==NULL)
    {
    cout<<"\n element not found";
    return x;
     }
    else if(loc->next==NULL)
    {
    cout<<"\n node containing"<<after<<"is last node";
    return x;
    }
    else
    {
    temp=loc->next;
    x=temp->val;
    loc->next=temp->next;
    free(temp);
    return x;
    }
    }

int deln(struct node **list,int s)
  {
    int i,x;
    struct node *ptr,*temp;
    ptr=*list;

    if(s==1)
    {
    x=ptr->val;
    *list=(*list)->next;
    free(ptr);
    return x;
    }
    else
    {
    temp=NULL;

   for(i=1;i<s;i++)
    {
      temp=ptr;
     ptr=ptr->next;
     }

     temp->next=ptr->next;
     x=ptr->val;
     free(ptr);
     return x;
     }
    }


int delbf(struct node **list,int before)
  {
    int x=-1;
    struct node *ptr,*q;

    if((*list)->val==before)
    {
    cout<<"\n node containing"<<before<<"is first node";
    return x;
    }

    ptr=*list;
    q=NULL;
    while((ptr!=NULL)&&(ptr->next->val!=before))
    {
    q=ptr;
    ptr=ptr->next;
    }
    if(ptr==NULL)
    {
    cout<<"\n element not found";
    return x;
    }
    else
    {
    if(q==NULL)
    {
    x=ptr->val;
    *list=(*list)->next;
    free(ptr);
    return x;
    }
    else
    {
    q->next=ptr->next;
    x=ptr->val;
    free(ptr);
    return x;
    }
    }
   }

void show(struct node *list)
{
struct node *p;
if(list==NULL)
{
cout<<"\n linked list is empty";
return;
}
cout<<"\n start->";
for(p=list;p!=NULL;p=p->next)
{
cout<<p->val<<"->";
}
cout<<"X";
}

void travrev(struct node *list)
{
if(list->next!=NULL)
travrev(list->next);
cout<<list->val<<"->";
}

void deletelist(struct node **list)
{
struct node *ptr;
while(*list!=NULL)
{
ptr=*list;
*list=(*list)->next;
free(ptr);
}
}


void main()
{
clrscr();
struct node *list;
list=NULL;
int value,z,n;
char choice;
int y;
while(1)
{
cout<<"\n enter choice:";
cout<<"\n a:insert in the begning";
cout<<"\n b:insert in the end";
cout<<"\n c:insert after a given value";
cout<<"\n d:insert before a given element";
cout<<"\n e:delete from the begning";
cout<<"\n f:delete from the end";
cout<<"\n g:delete after a given element";
cout<<"\n h:delete before a given element";
cout<<"\n i:to delete any node";
cout<<"\n j:display linked list";
cout<<"\n k:traverse in reverse order";
cout<<"\n l:exit\n";
cin>>choice;
switch(choice)
{
case 'a':
	 cout<<"\n enter the value";
	 cin>>value;
	 insertbeg(&list,value);
	 break;

case 'b':
	 cout<<"\n enter the value";
	 cin>>value;
	 insertend(&list,value);
	 break;
case 'c':
	 cout<<"\n enter the value";
	 cin>>value;
	 cout<<"\n enter value after which you wana insert:";
	 cin>>z;
	 addaf(list,value,z);
	 break;

case 'd':
	 cout<<"\n enter the value";
	 cin>>value;
	 cout<<"\n enter value before which you wana insert:";
	 cin>>z;
	 addbf(&list,value,z);
	 break;



case 'e':
	 y=delbeg(&list);
	 if(y==-1)
	 cout<<"\n linked list is empty";
	 else
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'f':
	 y=delend(&list);
	 if(y==-1)
	 cout<<"\n linked list is empty";
	 else
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'g':
	 cout<<"\n enter value after which you wana delete:";
	 cin>>z;
	 y=delaf(list,z);
	 if(y!=-1)
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'h':
	 cout<<"\n enter value before which you wana delete:";
	 cin>>z;
	 y=delbf(&list,z);
	 if(y!=-1)
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'i':
       cout<<"\n enter the node you want to del";
       cin>>n;
       y=deln(&list,n);
       cout<<"\n deleted value is:"<<y;
       break;

case 'j':
	 show(list);
	 break;

case 'k':
	 cout<<"\n Start->";
	 travrev(list);
	 cout<<"X";
	 break;

case 'l':
	  deletelist(&list);
	  exit(1);

default:
	 cout<<"\n illegal operation:";

	 }
     getch();
    }
     }