/* circular linked list */

#include<iostream.h>
#include<conio.h>
#include<alloc.h>
#include<process.h>


struct node
{
int val;
struct node *next;
};

struct node *list;

void insert(struct node **list,int value)
{
struct node *q;
q=(struct node *)malloc(sizeof(struct node));
q->val=value;

if(*list==NULL)
{
q->next=q;
*list=q;
}
else
{
q->next=(*list)->next;
(*list)->next=q;
*list=q;
}
}

void insertbeg(struct node *list,int value)
{
struct node *q;
q=(struct node *)malloc(sizeof(struct node));
q->val=value;
q->next=list->next;
list->next=q;
}

void insertend(struct node **list,int value)
{
 struct node *q;
 q=(struct node *)malloc(sizeof(struct node));
 q->val=value;
 q->next=(*list)->next;
 (*list)->next=q;
 *list=q;
 }



void show(struct node *list)
{
struct node *p;

p=list->next;
cout<<"\n";
do
{
cout<<p->val<<"->";
p=p->next;
}
while(p!=list->next);
cout<<p->val;
}

int delbeg(struct node *list)
{
int x;
struct node *q;
q=list->next;
x=q->val;
list->next=q->next;
free(q);
return x;
}

int delend(struct node **list)
{
int x;
struct node *temp,*ptr;
temp=(*list)->next;

if(temp==*list)
{
x=temp->val;
*list=NULL;
free(temp);
return x;
}
else
{
ptr=NULL;
while(temp!=*list)
{
ptr=temp;
temp=temp->next;
}
x=temp->val;
ptr->next=temp->next;
*list=ptr;
free(temp);
return x;
}
}

int deln(struct node *list,int s)
{
int z,i;
struct node *temp,*ptr;
if(s==1)
{
z=delbeg(list);
return z;
}
else
{
ptr=list->next;
temp=NULL;
for(i=1;i<s;i++)
{
temp=ptr;
ptr=ptr->next;
}

if(ptr==list)
{
z=delend(&list);
return z;
}
else
{
z=ptr->val;
temp->next=ptr->next;
free(ptr);
return z;
}
}
}

void main()
{
clrscr();
int value,n,y,s;
char choice;
cout<<"\n enter values";
cin>>value;

while(value)
{
insert(&list,value);
cin>>value;
}
cout<<"\n created circular queue is:";
show(list);

while(1)
{
cout<<"\n enter your choice:";
cout<<"\n a:to insert in the begining";
cout<<"\n b:to insert at the end";
cout<<"\n c:to delete from begining";
cout<<"\n d:to delete from end";
cout<<"\n e:to delete any node";
cout<<"\n f:to display:";
cout<<"\n g:exit";
cin>>choice;
switch(choice)
{
case 'a':
	cout<<"\n enter value:";
	cin>>n;
	insertbeg(list,n);
	break;
case 'b':
	 cout<<"\n enter value:";
	 cin>>n;
	 insertend(&list,n);
	 break;

case 'c':
	 y=delbeg(list);
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'd':
	 y=delend(&list);
	 cout<<"\n deleted value is:"<<y;
	 break;
case 'e':
	 cout<<"\n enter the node you wnat to delete";
	 cin>>s;
	 y=deln(list,s);
	 cout<<"\n deleted value is:"<<y;
	 break;


case 'f':
	show(list);
	break;

case 'g':
	exit(1);

default:
	cout<<"\n illegal operation";
	}

      getch();
	}
	}
