/* double linked list */

#include<iostream.h>
#include<conio.h>
#include<process.h>
#include<alloc.h>

struct node
{
int val;
struct node *next,*prev;
};

void insertbeg(struct node **list,int value);
void insertend(struct node **list,int value);
struct node *search(struct node *ptr,int item);
void insertaf(struct node *list,int y,int after);
void insertbf(struct node **list,int y,int before);
int delend(struct node **list);
int delbg(struct node **list);
int delaf(struct node *list,int after);
int delbf(struct node **list,int before);
int deln(struct node **list,int s);
void show(struct node *list);
void traversereve(struct node *list);
void deletelist(struct node **list);

void insertbeg(struct node **list,int value)
  {
   struct node *q;
   q=(struct node *)malloc(sizeof(struct node));
   q->val=value;

if(*list==NULL)
{
q->next=NULL;
q->prev=NULL;
*list=q;
}
else
{
q->prev=NULL;
q->next=*list;
(*list)->prev=q;
*list=q;
}
 }

void insertend(struct node **list,int value)
{
struct node *p,*q;
q=(struct node *)malloc(sizeof(struct node));
q->val=value;

if(*list==NULL)
{
q->prev=NULL;
q->next=NULL;
*list=q;
}

else
{
p=*list;
while(p->next!=NULL)
{
p=p->next;
}
p->next=q;
q->prev=p;
q->next=NULL;

}
}


struct node *search(struct node *ptr,int item)
 {
  {
   while((ptr!=NULL)&&(ptr->val!=item))
    {
     ptr=ptr->next;
    }
  if(ptr->val==item)
  return ptr;
  else
 return NULL;
   }
 }

void insertaf(struct node *list,int y,int after)
 {
  struct node *temp,*loc,*ptr;
  ptr=list;
  loc=search(ptr,after);

  if(loc==NULL)
  {
   cout<<"\n element not found";
   return;
   }

 temp= (struct node *)malloc(sizeof(struct node));
 temp->val=y;
 if(loc->next==NULL)
  {
   temp->next=NULL;
   loc->next=temp;
   temp->prev=loc;
    }
else
  {
   temp->prev=loc;
   temp->next=loc->next;
   (loc->next)->prev=temp;
   loc->next=temp;
    }
  }

void insertbf(struct node **list,int y,int before)
  {
    struct node *temp,*loc,*ptr;
    ptr=*list;
    loc=search(ptr,before);

    if(loc==NULL)
     {
      cout<<"\n element not found";
      return;
      }

    temp= (struct node *)malloc(sizeof(struct node));
    temp->val=y;

    if(loc->prev==NULL)
     {
      temp->prev=NULL;
      loc->prev=temp;
      temp->next=*list;
      *list=temp;
      }
    else
      {
       temp->prev=loc->prev;
       temp->next=loc;
      (loc->prev)->next=temp;
      loc->prev=temp;
       }
     }


int delaf(struct node *list,int after)
   {
    int x=-1;
    struct node *temp,*loc,*ptr;
    ptr=list;
    loc=search(ptr,after);

    if(loc==NULL)
    {
    cout<<"\n element not found";
    return x;
    }

   else if(loc->next==NULL)
   {
   cout<<"\n node contaning"<<after<<"is last node";
   return x;
   }

  else if((loc->next)->next==NULL)
    {
     temp=loc->next;
     x=temp->val;
     loc->next=NULL;
     free(temp);
     return x;
     }
     else
     {
       temp=loc->next;
       x=temp->val;
       loc->next=temp->next;
       (temp->next)->prev=loc;
       free(temp);
       return x;
       }
     }

int delbg(struct node **list)
   {
     int x=-1;
     struct node *ptr;
     if(*list==NULL)
     return x;

    else
      {
      if((*list)->next==NULL)
       {
       ptr=*list;
       x=ptr->val;
       *list=NULL;
       free(ptr);
       return x;
       }
       else
       {
       ptr=*list;
       x=ptr->val;
     *list=(*list)->next;
     (*list)->prev=NULL;
     free(ptr);
     return x;
     }
     }
     }

int delend(struct node **list)
  {
  int x=-1;
   struct node *temp,*loc,*ptr;
   ptr=*list;

   if(ptr==NULL)
    return x;

  else if(ptr->next==NULL)
   {
    temp=ptr;
    x=ptr->val;
    *list=NULL;
    free(temp);
    return x;
    }
  else
   {
    loc=ptr;
    temp=ptr->next;
    while(temp->next!=NULL)
     {
      loc=temp;
      temp=temp->next;
      }
      x=temp->val;
     loc->next=NULL;
     free(temp);
     return x;
     }
   }

int delbf(struct node **list,int before)
 {
  int x=-1;
  struct node *temp,*loc,*ptr;
  ptr=*list;
  loc=search(ptr,before);

  if(loc==NULL)
  {
   cout<<"\n element not found";
   return x;
   }

  else if(loc->prev==NULL)
   {
    cout<<"\n node contaning"<<before<<"is first node";
    return x;
    }

  else if((loc->prev)->prev==NULL)
   {
    temp=loc->prev;
    x=temp->val;
    loc->prev=NULL;
    *list=loc;
    free(temp);
    return x;
    }
 else
   {
    temp=loc->prev;
    x=temp->val;
    loc->prev=temp->prev;
    (temp->prev)->next=loc;
    free(temp);
    return x;
      }
    }

int deln(struct node **list,int s)
   {
     int i,x;
      struct node *temp,*ptr;
      ptr=*list;
      temp=NULL;

     for(i=1;i<s;i++)
     {
      temp=ptr;
      ptr=ptr->next;
      }

      if(ptr->prev==NULL)
      {
      x=ptr->val;
      *list=(*list)->next;
      (*list)->prev=NULL;
      free(ptr);
      return x;
      }

      else if(ptr->next==NULL)
      {
       temp->next=NULL;
       x=ptr->val;
       free(ptr);
       return x;
       }

      else
      {
      x=ptr->val;
      temp->next=ptr->next;
      ptr->next->prev=temp;
      free(ptr);
      return x;
     }
  }

void show(struct node *list)
{
struct node *p;
if(list==NULL)
cout<<"\n linked list is empty";
else
{
cout<<"\n start->";
for(p=list;p!=NULL;p=p->next)
{
cout<<p->val<<"->";
}
cout<<"X";
}
}

void traversereve(struct node *list)
{
struct node *ptr,*temp;

if(list==NULL)
cout<<"\n linked list is empty";
else
{
ptr=list;
temp=NULL;
while(ptr!=NULL)
{
temp=ptr;
ptr=ptr->next;
}

cout<<"\n start->";
while(temp!=NULL)
{
cout<<temp->val<<"->";
temp=temp->prev;
}
cout<<"X";
}
}


void deletelist(struct node **list)
{
struct node *ptr;
while(*list!=NULL)
{
ptr=*list;
*list=(*list)->next;
free(ptr);
}
}


void main()
{
clrscr();
struct node *list;
list=NULL;
int value,z,n;
char choice;
int y;
while(1)
{
cout<<"\n enter choice:";
cout<<"\n a:insert in the begning";
cout<<"\n b:insert in the end";
cout<<"\n c:insert after a given value";
cout<<"\n d:insert before a given element";
cout<<"\n e:delete from the begning";
cout<<"\n f:delete from the end";
cout<<"\n g:delete after a given element";
cout<<"\n h:delete before a given element";
cout<<"\n i:to delete any node";
cout<<"\n j:display linked list";
cout<<"\n k:traverse in reverse order:";
cout<<"\n l:exit\n";
cin>>choice;
switch(choice)
{
case 'a':
	 cout<<"\n enter the value";
	 cin>>value;
	 insertbeg(&list,value);
	 break;

case 'b':
	 cout<<"\n enter the value";
	 cin>>value;
	 insertend(&list,value);
	 break;
case 'c':
	 cout<<"\n enter the value";
	 cin>>value;
	 cout<<"\n enter value after which you wana insert:";
	 cin>>z;
	 insertaf(list,value,z);
	 break;

case 'd':
	 cout<<"\n enter the value";
	 cin>>value;
	 cout<<"\n enter value before which you wana insert:";
	 cin>>z;
	 insertbf(&list,value,z);
	 break;



case 'e':
	 y=delbg(&list);
	 if(y==-1)
	 {
	 cout<<"\ linked list is empty";
	 }
	 else
	 {
	 cout<<"\n deleted value is:"<<y;
	 }
	 break;

case 'f':
	 y=delend(&list);
	 if(y==-1)
	 {
	 cout<<"\ linked list is empty";
	 }
	 else
	 {
	 cout<<"\n deleted value is:"<<y;
	 }
	 break;

case 'g':
	 cout<<"\n enter value after which you wana delete:";
	 cin>>z;
	 y=delaf(list,z);
	 if(y!=-1)
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'h':
	 cout<<"\n enter value before which you wana delete:";
	 cin>>z;
	 y=delbf(&list,z);
	 if(y!=-1)
	 cout<<"\n deleted value is:"<<y;
	 break;

case 'i':
       cout<<"\n enter the node you want to del";
       cin>>n;
       y=deln(&list,n);
       cout<<"\n deleted value is:"<<y;
       break;

case 'j':
	 show(list);
	 break;
case 'k':
	 traversereve(list);
	 break;

case 'l':
	  deletelist(&list);
	  exit(1);

default:
	 cout<<"\n illegal operation:";

	 }
     getch();
    }
     }