//circular linked list
#include<iostream.h>
#include<conio.h>
#include<alloc.h>
#include<process.h>

struct node
{
	int val;
	struct node *next;
};

struct node *list;

void insert(struct node **list,int value)
{
	struct node *q;
	q=(struct node *)malloc(sizeof(struct node));
	q->val=value;
	if(*list==NULL)
	{
		q->next=q;
		*list=q;
	}
	else
	{
		q->next=(*list)->next;
		(*list)->next=q;
		*list=q;
	}
}

void insertbeg(struct node *list,int value)
{
	struct node *q;
	q=(struct node *)malloc(sizeof(struct node));
	q->val=value;
	q->next=list->next;
	list->next=q;
}

void insertend(struct node **list,int value)
{
	struct node *q;
	q=(struct node *)malloc(sizeof(struct node));
	q->val=value;
	q->next=(*list)->next;
	(*list)->next=q;
	*list=q;
}

void show(struct node *list)
{
	struct node *p;
	p=list->next;
	cout<<"\n";
	do
	{
		cout<<p->val<<"->";
		p=p->next;
	}
	while(p!=list->next);
		cout<<p->val;
}

int delbeg(struct node *list)
{
	int x;
	struct node *q;
	q=list->next;
	x=q->val;
	list->next=q->next;
	free(q);
	return x;
}

int delend(struct node **list)
{
	int x;
	struct node *temp,*ptr;
	temp=(*list)->next;
	if(temp==*list)
	{
		x=temp->val;
		*list=NULL;
		free(temp);
		return x;
	}
	else
	{
		ptr=NULL;
		while(temp!=*list)
		{
			ptr=temp;
			temp=temp->next;
		}
	x=temp->val;
	ptr->next=temp->next;
	*list=ptr;
	free(temp);
	return x;
	}
}

int deln(struct node *list,int s)
{
	int z,i;
	struct node *temp,*ptr;
	if(s==1)
	{
		z=delbeg(list);
		return z;
	}
	else
	{
		ptr=list->next;
		temp=NULL;
		for(i=1;i<s;i++)
		{
			temp=ptr;
			ptr=ptr->next;
		}
		if(ptr==list)
		{
			z=delend(&list);
			return z;
		}
		else
		{
			z=ptr->val;
			temp->next=ptr->next;
			free(ptr);
			return z;
		}
	}
}

void main()
{
	clrscr();
	int value,n,y,s;
	int choice;
	cout<<"\n Please enter values(enter 0 to terminate)";
	cin>>value;
	while(value)
	{
		insert(&list,value);
		cin>>value;
	}
	cout<<"\n created circular queue is:";
	show(list);
	while(1)
	{
		cout<<"\n Enter your choice:";
		cout<<"\n 1:to insert in the begining";
		cout<<"\n 2:to insert at the end";
		cout<<"\n 3:to delete from begining";
		cout<<"\n 4:to delete from end";
		cout<<"\n 5:to delete any node";
		cout<<"\n 6:to display:";
		cout<<"\n 7:exit";
		cout<<"\nPlease enter choice:";
		cin>>choice;
		switch(choice)
		{
		case 1:
			cout<<"\n enter value:";
			cin>>n;
			insertbeg(list,n);
			break;
		case 2:
			 cout<<"\n enter value:";
			 cin>>n;
			 insertend(&list,n);
			 break;

		case 3:
			 y=delbeg(list);
			 cout<<"\n deleted value is:"<<y;
			 break;

		case 4:
			 y=delend(&list);
			 cout<<"\n deleted value is:"<<y;
			 break;
		case 5:
			 cout<<"\n enter the node you wnat to delete";
			 cin>>s;
			 y=deln(list,s);
			 cout<<"\n deleted value is:"<<y;
			 break;
		case 6:
			show(list);
			break;
		case 7:
			exit(1);
		default:
			cout<<"\n illegal operation";
		}
		cout<<"\n\n\n\n\n\t\t**Press enter to return to main menu**";
		getch();
	}
}
