// WAP to implement strassen's matrix multiplication algorithm
#include<iostream.h>
#include<stdlib.h>
#include<conio.h>

void matsub(int a[][2],int b[][2],int c[][2]);
void matadd(int a[][2],int b[][2],int c[][2]);
void matmul(int a[][2],int b[][2],int c[][2]);
void printmat(int a[][2]);
void printmat(int a[][4]);

void printmat(int a[][2])
{
	int i,j;
	cout<<"The ans is \n";
	for(i=0;i<=1;i++)
	{
		cout<<"\n";
		for(j=0;j<=1;j++)
			cout<<a[i][j];
	 }
}

void printmat(int a[][4])
{
	int i,j;
	cout<<"The ans is \n";
	for(i=0;i<=3;i++)
	{
		cout<<"\n";
		for(j=0;j<=3;j++)
			cout<<a[i][j]<<"\t";
	}
}

void matmul(int a[][2],int b[][2],int c[][2])
{
	int i,j,k;
	for(i=0;i<=1;i++)
	for(j=0;j<=1;j++)
	{
		c[i][j]=0;
		for(k=0;k<=1;k++)
			c[i][j]=c[i][j]+(a[i][k]*b[k][j]);
	}
}

void matadd(int a[][2],int b[][2],int c[][2])
{
	int i,j;
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			c[i][j]=a[i][j]+b[i][j];

}

void matsub(int a[][2],int b[][2],int c[][2])
{
	int i,j;
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			c[i][j]=a[i][j]-b[i][j];
}

int main()
{
	int a11[2][2],a12[2][2],a21[2][2],a22[2][2],b11[2][2],b12[2][2],b21[2][2],b22[2][2];
	int i,j,k;

	cout<<"Enter first matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>a11[i][j];

	cout<<"Enter second matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>a12[i][j];

	cout<<"Enter third matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>a21[i][j];

	cout<<"Enter fourth matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>a22[i][j];

	cout<<"Enter fifth matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>b11[i][j];

	cout<<"Enter sixth matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>b12[i][j];

	cout<<"Enter seventh matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>b21[i][j];

	cout<<"Enter eighth matrix";
	for(i=0;i<=1;i++)
		for(j=0;j<=1;j++)
			cin>>b22[i][j];

	int m1[2][2],m2[2][2],m3[2][2],m4[2][2],m5[2][2],m6[2][2],m7[2][2],temp1[2][2],temp2[2][2];

	matadd(a11,a22,temp1);
	matadd(b11,b22,temp2);
	matmul(temp1,temp2,m1);

	matadd(a21,a22,temp1);
	matmul(temp1,b11,m2);

	matsub(b12,b22,temp1);
	matmul(a11,temp1,m3);

	matsub(b21,b11,temp1);
	matmul(a22,temp1,m4);
	matadd(a11,a12,temp1);
	matmul(temp1,b22,m5);

	matsub(a21,a11,temp1);
	matadd(b11,b12,temp2);
	matmul(temp1,temp2,m6);

	matsub(a12,a22,temp1);
	matadd(b21,b22,temp2);
	matmul(temp1,temp2,m7);

	int c11[2][2],c12[2][2],c21[2][2],c22[2][2];

	matadd(m1,m4,temp1);
	matsub(m5,m7,temp2);
	matsub(temp1,temp2,c11);

	matadd(m3,m5,c12);
	matadd(m2,m4,c21);

	matadd(m1,m3,temp1);
	matsub(m2,m6,temp2);
	matsub(temp1,temp2,c22);

	cout<<"\n";
	int ans[4][4];
	for(i=0;i<2;i++)
	{
		for(j=0;j<2;j++)
		{
			ans[i][j]=c11[i][j];
			ans[i][j+2]=c12[i][j];
			ans[i+2][j]=c21[i][j];
			ans[i+2][j+2]=c22[i][j];
		}
	}
	printmat(ans);
	getch();
	return 0;
}